diff -ruNp ejudge-2.3.18/super-serve.h ejudge/super-serve.h
--- ejudge-2.3.18/super-serve.h	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/super-serve.h	2011-07-11 09:02:04.429275495 +0400
@@ -1,9 +1,9 @@
 /* -*- c -*- */
-/* $Id: super-serve.h 5932 2010-07-07 09:00:22Z cher $ */
+/* $Id: super-serve.h 6359 2011-06-10 20:04:28Z cher $ */
 #ifndef __SUPER_SERVE_H__
 #define __SUPER_SERVE_H__
 
-/* Copyright (C) 2004-2010 Alexander Chernov <cher@ejudge.ru> */
+/* Copyright (C) 2004-2011 Alexander Chernov <cher@ejudge.ru> */
 
 /*
  * This program is free software; you can redistribute it and/or modify
@@ -20,6 +20,7 @@
 #include "ej_types.h"
 
 #include "opcaps.h"
+#include "bitset.h"
 
 #include <time.h>
 
@@ -83,7 +84,7 @@ struct section_language_data;
 struct section_problem_data;
 struct section_tester_data;
 
-/* sizeof(struct sid_state) == 416 */
+/* sizeof(struct sid_state) == 480 */
 struct sid_state
 {
   struct sid_state *next;
@@ -207,9 +208,32 @@ struct sid_state
   unsigned char *var_footer_text;
 
   unsigned char *compile_home_dir;
+
+  ejintbool_t user_filter_set;
+  unsigned char *user_filter;
+  int user_offset;
+  int user_count;
+
+  ejintbool_t group_filter_set;
+  unsigned char *group_filter;
+  int group_offset;
+  int group_count;
+
+  ejintbool_t contest_user_filter_set;
+  unsigned char *contest_user_filter;
+  int contest_user_offset;
+  int contest_user_count;
+
+  ejintbool_t group_user_filter_set;
+  unsigned char *group_user_filter;
+  int group_user_offset;
+  int group_user_count;
+
+  bitset_t marked;
 };
 
 struct sid_state;
+struct userlist_conn;
 struct super_http_request_info
 {
   // program invocation arguments
@@ -226,6 +250,7 @@ struct super_http_request_info
 
   const struct ejudge_cfg *config;
   struct sid_state *ss;
+  struct userlist_clnt *userlist_clnt;
 
   int opcode;
 
diff -ruNp ejudge-2.3.18/uldb_plugin.h ejudge/uldb_plugin.h
--- ejudge-2.3.18/uldb_plugin.h	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/uldb_plugin.h	2011-07-11 09:02:04.690270697 +0400
@@ -1,10 +1,10 @@
 /* -*- c -*- */
-/* $Id: uldb_plugin.h 5810 2010-05-28 14:48:51Z cher $ */
+/* $Id: uldb_plugin.h 6314 2011-05-08 07:01:11Z cher $ */
 
 #ifndef __ULDB_PLUGIN_H__
 #define __ULDB_PLUGIN_H__
 
-/* Copyright (C) 2006-2010 Alexander Chernov <cher@ejudge.ru> */
+/* Copyright (C) 2006-2011 Alexander Chernov <cher@ejudge.ru> */
 
 /*
  * This program is free software; you can redistribute it and/or modify
@@ -74,10 +74,20 @@ struct uldb_plugin_iface
   // get login by the user_id, login allocated on heap
   unsigned char *(*get_login)(void *, int);
   // create a new user
-  int (*new_user)(void *, const unsigned char *login,
+  int (*new_user)(void *,
+                  const unsigned char *login,
                   const unsigned char *email,
+                  int passwd_method,
                   const unsigned char *reg_passwd,
-                  int simple_reg_flag);
+                  int is_privileged,
+                  int is_invisible,
+                  int is_banned,
+                  int is_locked,
+                  int show_login,
+                  int show_email,
+                  int read_only,
+                  int never_clean,
+                  int simple_registration);
   // remove a user
   int (*remove_user)(void *, int);
   // find a cookie
@@ -133,7 +143,7 @@ struct uldb_plugin_iface
   // set the team password
   int (*set_team_passwd)(void *, int, int, int, const unsigned char *, time_t, int *);
   // register a user for contest
-  int (*register_contest)(void *, int, int, int, time_t, const struct userlist_contest**);
+  int (*register_contest)(void *, int, int, int, int, time_t, const struct userlist_contest**);
   // remove a particular member from a user
   int (*remove_member)(void *, int, int, int, time_t, int *);
   // check if the user is read-only
@@ -226,6 +236,18 @@ struct uldb_plugin_iface
   int (*create_group_member)(void *, int group_id, int user_id);
   // remove a group member
   int (*remove_group_member)(void *, int group_id, int user_id);
+  // list users
+  ptr_iterator_t (*get_brief_list_iterator_2)(void *, int contest_id, int group_id, const unsigned char *filter, int offset, int count);
+  // get the total count of users for the given filter
+  int (*get_user_count)(void *, int contest_id, int group_id, const unsigned char *filter, long long *p_count);
+  // get the group iterator
+  ptr_iterator_t (*get_group_iterator_2)(void *, const unsigned char *filter, int offset, int count);
+  // get the total number of groups to display
+  int (*get_group_count)(void *, const unsigned char *filter, long long *p_count);
+  // get the previous user
+  int (*get_prev_user_id)(void *, int contest_id, int group_id, int user_id, const unsigned char *filter, int *p_user_id);
+  // get the next user
+  int (*get_next_user_id)(void *, int contest_id, int group_id, int user_id, const unsigned char *filter, int *p_user_id);
 };
 
 /* default plugin: compiled into userlist-server */
diff -ruNp ejudge-2.3.18/uldb_plugin_xml.c ejudge/uldb_plugin_xml.c
--- ejudge-2.3.18/uldb_plugin_xml.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/uldb_plugin_xml.c	2011-07-11 09:02:04.427275531 +0400
@@ -1,5 +1,5 @@
 /* -*- mode: c -*- */
-/* $Id: uldb_plugin_xml.c 6162 2011-03-27 07:07:27Z cher $ */
+/* $Id: uldb_plugin_xml.c 6379 2011-06-24 18:47:55Z cher $ */
 
 /* Copyright (C) 2006-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -58,8 +58,17 @@ static void forced_sync_func(void *);
 static unsigned char *get_login_func(void *, int);
 static int new_user_func(void *, const unsigned char *login,
                          const unsigned char *email,
+                         int passwd_method,
                          const unsigned char *reg_passwd,
-                         int simple_reg_flag);
+                         int is_privileged,
+                         int is_invisible,
+                         int is_banned,
+                         int is_locked,
+                         int show_login,
+                         int show_email,
+                         int read_only,
+                         int never_clean,
+                         int simple_registration);
 static int remove_user_func(void *, int);
 static int get_cookie_func(void *, ej_cookie_t,
                            const struct userlist_cookie **);
@@ -93,7 +102,7 @@ static ptr_iterator_t get_standings_list
 static int check_user_func(void *, int);
 static int set_reg_passwd_func(void *, int, int, const unsigned char *, time_t);
 static int set_team_passwd_func(void *, int, int, int, const unsigned char *, time_t, int *);
-static int register_contest_func(void *, int, int, int, time_t, const struct userlist_contest **);
+static int register_contest_func(void *, int, int, int, int, time_t, const struct userlist_contest **);
 static int remove_member_func(void *, int, int, int, time_t, int *);
 static int is_read_only_func(void *, int, int);
 static ptr_iterator_t get_info_list_iterator_func(void *, int, unsigned int);
@@ -175,6 +184,48 @@ static int
 create_group_member_func(void *data, int group_id, int user_id);
 static int
 remove_group_member_func(void *data, int group_id, int user_id);
+static ptr_iterator_t
+get_brief_list_iterator_2_func(
+        void *data,
+        int contest_id,
+        int group_id,
+        const unsigned char *filter,
+        int offset,
+        int count);
+static int
+get_user_count_func(
+        void *data,
+        int contest_id,
+        int group_id,
+        const unsigned char *filter,
+        long long *p_count);
+static ptr_iterator_t
+get_group_iterator_2_func(
+        void *data,
+        const unsigned char *filter,
+        int offset,
+        int count);
+static int
+get_group_count_func(
+        void *data,
+        const unsigned char *filter,
+        long long *p_count);
+static int
+get_prev_user_id_func(
+        void *data,
+        int contest_id,
+        int group_id,
+        int user_id,
+        const unsigned char *filter,
+        int *p_user_id);
+static int
+get_next_user_id_func(
+        void *data,
+        int contest_id,
+        int group_id,
+        int user_id,
+        const unsigned char *filter,
+        int *p_user_id);
 
 struct uldb_plugin_iface uldb_plugin_xml =
 {
@@ -276,6 +327,12 @@ struct uldb_plugin_iface uldb_plugin_xml
   get_group_member_iterator_func,
   create_group_member_func,
   remove_group_member_func,
+  get_brief_list_iterator_2_func,
+  get_user_count_func,
+  get_group_iterator_2_func,
+  get_group_count_func,
+  get_prev_user_id_func,
+  get_next_user_id_func,
 };
 
 struct uldb_xml_state
@@ -330,6 +387,18 @@ struct info_list_iterator
   int user_id;
 };
 
+struct brief_list_2_iterator
+{
+  struct ptr_iterator b;
+  struct uldb_xml_state *state;
+  int contest_id;
+  int group_id;
+  unsigned char *filter;
+  int offset;
+  int count;
+  int user_id;
+};
+
 static struct userlist_user_info *
 userlist_clone_user_info(
         struct userlist_user *u,
@@ -650,11 +719,21 @@ get_login_func(void *data, int user_id)
 }
 
 static int
-new_user_func(void *data,
-              const unsigned char *login,
-              const unsigned char *email,
-              const unsigned char *reg_passwd,
-              int simple_reg_flag)
+new_user_func(
+        void *data,
+        const unsigned char *login,
+        const unsigned char *email,
+        int passwd_method,
+        const unsigned char *reg_passwd,
+        int is_privileged,
+        int is_invisible,
+        int is_banned,
+        int is_locked,
+        int show_login,
+        int show_email,
+        int read_only,
+        int never_clean,
+        int simple_registration)
 {
   struct uldb_xml_state *state = (struct uldb_xml_state*) data;
   struct userlist_list *ul = state->userlist;
@@ -690,11 +769,19 @@ new_user_func(void *data,
   u->login = xstrdup(login);
   if (email) u->email = xstrdup(email);
   u->login_hash = userlist_login_hash(login);
-  u->simple_registration = simple_reg_flag;
+  u->is_privileged = is_privileged;
+  u->is_invisible = is_invisible;
+  u->is_banned = is_banned;
+  u->is_locked = is_locked;
+  u->show_login = show_login;
+  u->show_email = show_email;
+  u->read_only = read_only;
+  u->never_clean = never_clean;
+  u->simple_registration = simple_registration;
 
   if (reg_passwd) {
     u->passwd = xstrdup(reg_passwd);
-    u->passwd_method = USERLIST_PWD_PLAIN;
+    u->passwd_method = passwd_method;
   }
 
   if (ul->login_hash_table) {
@@ -1424,6 +1511,7 @@ register_contest_func(void *data,
                       int user_id,
                       int contest_id,
                       int status,
+                      int flags,
                       time_t cur_time,
                       const struct userlist_contest **p_c)
 {
@@ -1455,6 +1543,7 @@ register_contest_func(void *data,
   xml_link_node_last(u->contests, &c->b);
   c->id = contest_id;
   c->status = status;
+  c->flags = flags;
   c->create_time = cur_time;
 
   state->dirty = 1;
@@ -1748,6 +1837,7 @@ set_reg_flags_func(void *data, int user_
   case 1: new_value |= value; break;
   case 2: new_value &= ~value; break;
   case 3: new_value ^= value; break;
+  case 4: new_value = value; break;
   }
   if (new_value == c->flags) return 0;
 
@@ -3742,6 +3832,357 @@ remove_group_member_func(void *data, int
   return 0;
 }
 
+static void
+brief_list_2_do_skip(
+        struct brief_list_2_iterator *iter,
+        const struct userlist_list *ul)
+{
+  const struct userlist_user *u;
+  const struct xml_tree *t;
+  const struct userlist_contest *c;
+  const struct userlist_groupmember *gm;
+
+  for (;; ++iter->user_id) {
+    if (iter->user_id >= ul->user_map_size) return;
+    if (!(u = ul->user_map[iter->user_id])) continue;
+    if (iter->contest_id > 0 && iter->group_id > 0) {
+      if (!u->group_first) continue;
+      for (gm = (const struct userlist_groupmember*) u->group_first;
+           gm && gm->group_id < iter->group_id;
+           gm = (struct userlist_groupmember*) gm->group_next) {
+      }
+      if (!gm || gm->group_id != iter->group_id) continue;
+      if (!u->contests) continue;
+      for (t = u->contests->first_down; t; t = t->right) {
+        c = (const struct userlist_contest*) t;
+        if (c->id == iter->contest_id) {
+          if (iter->offset <= 0) return;
+          --iter->offset;
+          break;
+        }
+      }
+    } else if (iter->group_id > 0) {
+      if (!u->group_first) continue;
+      for (gm = (const struct userlist_groupmember*) u->group_first;
+           gm && gm->group_id < iter->group_id;
+           gm = (struct userlist_groupmember*) gm->group_next) {
+      }
+      if (!gm || gm->group_id != iter->group_id) continue;
+      if (iter->offset <= 0) return;
+      --iter->offset;
+    } else if (iter->contest_id > 0) {
+      if (!u->contests) continue;
+      for (t = u->contests->first_down; t; t = t->right) {
+        c = (const struct userlist_contest*) t;
+        if (c->id == iter->contest_id) {
+          if (iter->offset <= 0) return;
+          --iter->offset;
+          break;
+        }
+      }
+    } else {
+      if (iter->offset <= 0) return;
+      --iter->offset;
+      continue;
+    }
+  }
+}
+
+static int
+brief_list_2_iterator_has_next_func(ptr_iterator_t data)
+{
+  struct brief_list_2_iterator *iter = (struct brief_list_2_iterator*) data;
+  struct userlist_list *ul = iter->state->userlist;
+
+  if (iter->count <= 0) return 0;
+  brief_list_2_do_skip(iter, ul);
+  return (iter->user_id < ul->user_map_size);
+}
+static const void *
+brief_list_2_iterator_get_func(ptr_iterator_t data)
+{
+  struct brief_list_2_iterator *iter = (struct brief_list_2_iterator*) data;
+  struct userlist_list *ul = iter->state->userlist;
+
+  if (iter->count <= 0) return 0;
+  brief_list_2_do_skip(iter, ul);
+  if (iter->user_id >= ul->user_map_size) return 0;
+  return (const void *) ul->user_map[iter->user_id];
+}
+static void
+brief_list_2_iterator_next_func(ptr_iterator_t data)
+{
+  struct brief_list_2_iterator *iter = (struct brief_list_2_iterator*) data;
+  struct userlist_list *ul = iter->state->userlist;
+
+  if (iter->count <= 0) return;
+  if (iter->user_id < ul->user_map_size) iter->user_id++;
+  --iter->count;
+  brief_list_2_do_skip(iter, ul);
+}
+
+static void
+brief_list_2_iterator_destroy_func(ptr_iterator_t data)
+{
+  struct brief_list_2_iterator *iter = (struct brief_list_2_iterator*) data;
+  xfree(iter->filter);
+  xfree(iter);
+}
+
+static struct ptr_iterator brief_list_2_iterator_funcs =
+{
+  brief_list_2_iterator_has_next_func,
+  brief_list_2_iterator_get_func,
+  brief_list_2_iterator_next_func,
+  brief_list_2_iterator_destroy_func,
+};
+
+static ptr_iterator_t
+get_brief_list_iterator_2_func(
+        void *data,
+        int contest_id,
+        int group_id,
+        const unsigned char *filter,
+        int offset,
+        int count)
+{
+  struct uldb_xml_state *state = (struct uldb_xml_state*) data;
+  struct brief_list_2_iterator *iter;
+
+  if (offset < 0) offset = 0;
+  if (count < 0) count = 0;
+  if (offset + count < 0) count = 0;
+
+  XCALLOC(iter, 1);
+  iter->b = brief_list_2_iterator_funcs;
+  iter->state = state;
+  iter->contest_id = contest_id;
+  iter->group_id = group_id;
+  if (filter) iter->filter = xstrdup(filter);
+  iter->offset = offset;
+  iter->count = count;
+  iter->user_id = 0;
+  return (ptr_iterator_t) iter;
+}
+
+static int
+get_user_count_func(
+        void *data,
+        int contest_id,
+        int group_id,
+        const unsigned char *filter,
+        long long *p_count)
+{
+  struct uldb_xml_state *state = (struct uldb_xml_state*) data;
+  int i;
+  long long count = 0;
+
+  for (i = 0; i < state->userlist->user_map_size; ++i) {
+    if (state->userlist->user_map[i]) {
+      ++count;
+    }
+  }
+
+  if (p_count) *p_count = count;
+  return 0;
+}
+
+struct group_iterator_2
+{
+  struct ptr_iterator b;
+
+  struct uldb_xml_state *state;
+  unsigned char *filter;
+  int offset;
+  int count;
+
+  int group_id;
+};
+
+static int
+group_iterator_2_has_next_func(ptr_iterator_t data)
+{
+  struct group_iterator_2 *iter = (struct group_iterator_2 *) data;
+  struct userlist_list *ul;
+
+  if (!iter->state || !(ul = iter->state->userlist)) return 0;
+  if (ul->group_map_size <= 0 || iter->count <= 0) return 0;
+  return iter->group_id < ul->group_map_size;
+}
+static const void *
+group_iterator_2_get_func(ptr_iterator_t data)
+{
+  struct group_iterator_2 *iter = (struct group_iterator_2 *) data;
+  struct userlist_list *ul;
+
+  if (!iter->state || !(ul = iter->state->userlist)) return 0;
+  if (ul->group_map_size <= 0 || iter->count <= 0) return 0;
+  if (iter->group_id >= ul->group_map_size) return NULL;
+  return ul->group_map[iter->group_id];
+}
+static void
+group_iterator_2_next_func(ptr_iterator_t data)
+{
+  struct group_iterator_2 *iter = (struct group_iterator_2 *) data;
+  struct userlist_list *ul;
+
+  if (!iter->state || !(ul = iter->state->userlist)) return;
+  if (ul->group_map_size <= 0 || iter->count <= 0) return;
+  if (iter->group_id >= ul->group_map_size) return;
+  --iter->count; ++iter->group_id;
+  while (iter->group_id < ul->group_map_size && !ul->group_map[iter->group_id]) {
+    ++iter->group_id;
+  }
+}
+static void
+group_iterator_2_destroy_func(ptr_iterator_t data)
+{
+  struct group_iterator_2 *iter = (struct group_iterator_2 *) data;
+  xfree(iter->filter);
+  xfree(iter);
+}
+
+static struct ptr_iterator group_iterator_2_funcs =
+{
+  group_iterator_2_has_next_func,
+  group_iterator_2_get_func,
+  group_iterator_2_next_func,
+  group_iterator_2_destroy_func,
+};
+
+static ptr_iterator_t
+get_group_iterator_2_func(
+        void *data,
+        const unsigned char *filter,
+        int offset,
+        int count)
+{
+  struct uldb_xml_state *state = (struct uldb_xml_state*) data;
+  struct group_iterator_2 *iter = 0;
+  const struct userlist_list *ul = state->userlist;
+
+  if (offset < 0) offset = 0;
+  if (count < 0) count = 0;
+
+  XCALLOC(iter, 1);
+  iter->b = group_iterator_2_funcs;
+  iter->state = state;
+  iter->filter = xstrdup(filter);
+  iter->offset = offset;
+  iter->count = count;
+  iter->group_id = 0;
+
+  if (ul->group_map_size > 0 || iter->count > 0) {
+    while (iter->group_id < ul->group_map_size && !ul->group_map[iter->group_id]) {
+      ++iter->group_id;
+    }
+    while (iter->offset > 0 && iter->group_id < ul->group_map_size && ul->group_map[iter->group_id]) {
+      --iter->offset;
+      ++iter->group_id;
+      while (iter->group_id < ul->group_map_size && !ul->group_map[iter->group_id]) {
+        ++iter->group_id;
+      }
+    }
+  }
+
+  return (ptr_iterator_t) iter;
+}
+
+static int
+get_group_count_func(
+        void *data,
+        const unsigned char *filter,
+        long long *p_count)
+{
+  struct uldb_xml_state *state = (struct uldb_xml_state*) data;
+  int i;
+  long long count = 0;
+
+  for (i = 0; i < state->userlist->group_map_size; ++i) {
+    if (state->userlist->group_map[i]) {
+      ++count;
+    }
+  }
+
+  if (p_count) *p_count = count;
+  return 0;
+}
+
+static int
+check_user_match(const struct userlist_user *u, int contest_id, int group_id, const unsigned char *filter)
+{
+  const struct xml_tree *t;
+  const struct userlist_contest *c;
+  const struct userlist_groupmember *m;
+
+  if (!u) return 0;
+  if (contest_id > 0) {
+    if (!u->contests) return 0;
+    for (t = u->contests->first_down; t; t = t->right) {
+      c = (const struct userlist_contest*) t;
+      if (c->id == contest_id) {
+        break;
+      }
+    }
+    if (!t) return 0;
+  }
+  if (group_id > 0) {
+    if (!u->group_first) return 0;
+    for (t = u->group_first; t; t = m->group_next) {
+      m = (const struct userlist_groupmember*) t;
+      if (m->group_id == group_id) break;
+    }
+    if (!t) return 0;
+  }
+
+  return 1;
+}
+
+static int
+get_prev_user_id_func(
+        void *data,
+        int contest_id,
+        int group_id,
+        int user_id,
+        const unsigned char *filter,
+        int *p_user_id)
+{
+  struct uldb_xml_state *state = (struct uldb_xml_state*) data;
+  struct userlist_list *ul = state->userlist;
+
+  if (user_id > ul->user_map_size) user_id = ul->user_map_size;
+  for (--user_id;
+       user_id > 0 && !check_user_match(ul->user_map[user_id], contest_id, group_id, filter);
+       --user_id) {
+  }
+
+  if (p_user_id) *p_user_id = user_id;
+  return 0;
+}
+
+static int
+get_next_user_id_func(
+        void *data,
+        int contest_id,
+        int group_id,
+        int user_id,
+        const unsigned char *filter,
+        int *p_user_id)
+{
+  struct uldb_xml_state *state = (struct uldb_xml_state*) data;
+  struct userlist_list *ul = state->userlist;
+
+  if (user_id < 0) user_id = 0;
+  for (++user_id;
+       user_id < ul->user_map_size && !check_user_match(ul->user_map[user_id], contest_id, group_id, filter);
+       ++user_id) {
+  }
+  if (user_id >= ul->user_map_size) user_id = 0;
+
+  if (p_user_id) *p_user_id = user_id;
+  return 0;
+}
+
 /*
  * Local variables:
  *  compile-command: "make"
diff -ruNp ejudge-2.3.18/unix/ChangeLog ejudge/unix/ChangeLog
--- ejudge-2.3.18/unix/ChangeLog	2011-04-10 09:25:17.000000000 +0400
+++ ejudge/unix/ChangeLog	2011-07-11 09:01:59.716362041 +0400
@@ -1,3 +1,8 @@
+2011-06-18 (r6367) Alexander Chernov  <cher@ejudge.ru>
+
+	* reuse_exec.c:
+	(linux_set_secure_exec_supported_flag) check for 'dup' is removed.
+
 2011-03-31 (r6208) Alexander Chernov  <cher@ejudge.ru>
 
 	* reuse_exec.c:
@@ -718,5 +723,5 @@
 
 END
 
-	$Id: ChangeLog 6245 2011-04-10 05:24:07Z cher $
+	$Id: ChangeLog 6397 2011-07-06 05:01:19Z cher $
 
diff -ruNp ejudge-2.3.18/unix/reuse_exec.c ejudge/unix/reuse_exec.c
--- ejudge-2.3.18/unix/reuse_exec.c	2011-04-10 09:25:17.000000000 +0400
+++ ejudge/unix/reuse_exec.c	2011-07-11 09:01:59.733361729 +0400
@@ -1,4 +1,4 @@
-/* $Id: reuse_exec.c 6234 2011-04-08 17:43:28Z cher $ */
+/* $Id: reuse_exec.c 6367 2011-06-18 18:54:53Z cher $ */
 
 /* Copyright (C) 1998-2011 Alexander Chernov <cher@ejudge.ru> */
 /* Created: <1998-01-21 14:33:28 cher> */
@@ -2282,7 +2282,7 @@ linux_set_secure_exec_supported_flag(voi
 
   if (!pid) {
     if (ptrace(0x4281, 0, 0, 0) < 0) _exit(1);
-    if (dup(0) >= 0) _exit(1);
+    //if (dup(0) >= 0) _exit(1);
     _exit(0);
   }
 
diff -ruNp ejudge-2.3.18/userlist.c ejudge/userlist.c
--- ejudge-2.3.18/userlist.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/userlist.c	2011-07-11 09:02:04.188279925 +0400
@@ -1,5 +1,5 @@
 /* -*- mode: c -*- */
-/* $Id: userlist.c 6146 2011-03-26 10:47:14Z cher $ */
+/* $Id: userlist.c 6314 2011-05-08 07:01:11Z cher $ */
 
 /* Copyright (C) 2002-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -1274,6 +1274,10 @@ static const int primes[] =
   262147,
   524309,
   1048583,
+  2097169,
+  4194319,
+  8388617,
+  16777259,
   0,
 };
 
@@ -1322,7 +1326,11 @@ userlist_build_login_hash(struct userlis
     p->login_hash_table[j] = u;
   }
   rdtscll(tsc2);
-  tsc2 = (tsc2 - tsc1) * 1000000 / cpu_frequency;
+  if (cpu_frequency > 0) {
+    tsc2 = (tsc2 - tsc1) * 1000000 / cpu_frequency;
+  } else {
+    tsc2 = tsc2 - tsc1;
+  }
 
   info("login hashtable: size = %" EJ_PRINTF_ZSPEC "u, shift = %" EJ_PRINTF_ZSPEC "u, thresh = %" EJ_PRINTF_ZSPEC "u, current = %" EJ_PRINTF_ZSPEC "u",
        EJ_PRINTF_ZCAST(p->login_hash_size), EJ_PRINTF_ZCAST(p->login_hash_step),
@@ -1409,7 +1417,11 @@ userlist_build_cookie_hash(struct userli
   }
 
   rdtscll(tsc2);
-  tsc2 = (tsc2 - tsc1) * 1000000 / cpu_frequency;
+  if (cpu_frequency > 0) {
+    tsc2 = (tsc2 - tsc1) * 1000000 / cpu_frequency;
+  } else {
+    tsc2 = tsc2 - tsc1;
+  }
 
   info("cookie hashtable: size = %" EJ_PRINTF_ZSPEC "u, step = %" EJ_PRINTF_ZSPEC "u, thresh = %" EJ_PRINTF_ZSPEC "u, current = %" EJ_PRINTF_ZSPEC "u",
        EJ_PRINTF_ZCAST(p->cookie_hash_size), EJ_PRINTF_ZCAST(p->cookie_hash_step),
diff -ruNp ejudge-2.3.18/userlist_clnt/ChangeLog ejudge/userlist_clnt/ChangeLog
--- ejudge-2.3.18/userlist_clnt/ChangeLog	2011-04-10 09:25:23.000000000 +0400
+++ ejudge/userlist_clnt/ChangeLog	2011-07-11 09:02:03.757287847 +0400
@@ -1,3 +1,31 @@
+2011-05-08 (r6315) Alexander Chernov  <cher@ejudge.ru>
+
+	* get_prev_user_id.c:
+	initial revision
+
+2011-05-01 (r6289) Alexander Chernov  <cher@ejudge.ru>
+
+	* create_user_2.c:
+	initial revision
+
+2011-04-22 (r6262) Alexander Chernov  <cher@ejudge.ru>
+
+	* get_count.c:
+	(userlist_clnt_get_count) 'group_id' parameter is added.
+
+	* list_users_2.c:
+	(userlist_clnt_list_users_2) 'group_id' parameter is added.
+
+2011-04-20 (r6254) Alexander Chernov  <cher@ejudge.ru>
+
+	* get_count.c:
+	initial revision
+
+2011-04-19 (r6249) Alexander Chernov  <cher@ejudge.ru>
+
+	* list_users_2.c:
+	initial revision
+
 2011-03-27 (r6169) Alexander Chernov  <cher@ejudge.ru>
 
 	* send_packet.c:
diff -ruNp ejudge-2.3.18/userlist_clnt/create_user_2.c ejudge/userlist_clnt/create_user_2.c
--- ejudge-2.3.18/userlist_clnt/create_user_2.c	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/userlist_clnt/create_user_2.c	2011-07-11 09:02:03.735288253 +0400
@@ -0,0 +1,137 @@
+/* -*- mode: c -*- */
+/* $Id: create_user_2.c 6296 2011-05-02 20:57:23Z cher $ */
+
+/* Copyright (C) 2011 Alexander Chernov <cher@ejudge.ru> */
+
+/*
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#include "userlist_clnt/private.h"
+
+enum { MAX_LEN = 65535, MAX_SIZE = 1024*1024 };
+
+int
+userlist_clnt_create_user_2(
+        struct userlist_clnt *clnt,
+        int cmd,
+        const struct userlist_pk_create_user_2 *params,
+        const unsigned char *login_str,
+        const unsigned char *email_str,
+        const unsigned char *reg_password_str,
+        const unsigned char *cnts_password_str,
+        const unsigned char *cnts_name_str,
+        int *p_user_id)
+{
+  if (!params) return -ULS_ERR_PROTOCOL;
+  if (!login_str) login_str = "";
+  if (!email_str) email_str = "";
+  if (!reg_password_str) reg_password_str = "";
+  if (!cnts_password_str) cnts_password_str = "";
+  if (!cnts_name_str) cnts_name_str = "";
+
+  size_t login_len = strlen(login_str);
+  if (login_len > MAX_LEN) return -ULS_ERR_PROTOCOL;
+  size_t email_len = strlen(email_str);
+  if (email_len > MAX_LEN) return -ULS_ERR_PROTOCOL;
+  size_t reg_password_len = strlen(reg_password_str);
+  if (reg_password_len > MAX_LEN) return -ULS_ERR_PROTOCOL;
+  size_t cnts_password_len = strlen(cnts_password_str);
+  if (cnts_password_len > MAX_LEN) return -ULS_ERR_PROTOCOL;
+  size_t cnts_name_len = strlen(cnts_name_str);
+  if (cnts_name_len > MAX_LEN) return -ULS_ERR_PROTOCOL;
+
+  size_t out_size = sizeof(struct userlist_pk_create_user_2) + login_len + email_len + reg_password_len + cnts_password_len + cnts_name_len;
+  if (out_size > MAX_SIZE) return -ULS_ERR_PROTOCOL;
+
+  struct userlist_pk_create_user_2 *out = (struct userlist_pk_create_user_2*) xcalloc(out_size, 1);
+  unsigned char *login_ptr = out->data;
+  unsigned char *email_ptr = login_ptr + login_len + 1;
+  unsigned char *reg_password_ptr = email_ptr + email_len + 1;
+  unsigned char *cnts_password_ptr = reg_password_ptr + reg_password_len + 1;
+  unsigned char *cnts_name_ptr = cnts_password_ptr + cnts_password_len + 1;
+
+  out->request_id = cmd;
+  out->login_len = login_len;
+  out->email_len = email_len;
+  out->send_email_flag = params->send_email_flag;
+  out->confirm_email_flag = params->confirm_email_flag;
+  out->random_password_flag = params->random_password_flag;
+  out->reg_password_len = reg_password_len;
+  out->use_sha1_flag = params->use_sha1_flag;
+  out->is_privileged_flag = params->is_privileged_flag;
+  out->is_invisible_flag = params->is_invisible_flag;
+  out->is_banned_flag = params->is_banned_flag;
+  out->is_locked_flag = params->is_locked_flag;
+  out->show_login_flag = params->show_login_flag;
+  out->show_email_flag = params->show_email_flag;
+  out->read_only_flag = params->read_only_flag;
+  out->never_clean_flag = params->never_clean_flag;
+  out->simple_registration_flag = params->simple_registration_flag;
+  out->contest_id = params->contest_id;
+  out->cnts_status = params->cnts_status;
+  out->cnts_is_invisible_flag = params->cnts_is_invisible_flag;
+  out->cnts_is_banned_flag = params->cnts_is_banned_flag;
+  out->cnts_is_locked_flag = params->cnts_is_locked_flag;
+  out->cnts_is_incomplete_flag = params->cnts_is_incomplete_flag;
+  out->cnts_is_disqualified_flag = params->cnts_is_disqualified_flag;
+  out->cnts_use_reg_passwd_flag = params->cnts_use_reg_passwd_flag;
+  out->cnts_set_null_passwd_flag = params->cnts_set_null_passwd_flag;
+  out->cnts_random_password_flag = params->cnts_random_password_flag;
+  out->cnts_password_len = cnts_password_len;
+  out->cnts_use_sha1_flag = params->cnts_use_sha1_flag;
+  out->cnts_name_len = cnts_name_len;
+  out->group_id = params->group_id;
+
+  memcpy(login_ptr, login_str, login_len + 1);
+  memcpy(email_ptr, email_str, email_len + 1);
+  memcpy(reg_password_ptr, reg_password_str, reg_password_len + 1);
+  memcpy(cnts_password_ptr, cnts_password_str, cnts_password_len + 1);
+  memcpy(cnts_name_ptr, cnts_name_str, cnts_name_len + 1);
+
+  int r = 0;
+  if ((r = userlist_clnt_send_packet(clnt, out_size, out)) < 0) return r;
+
+  size_t in_size = 0;
+  void *void_in = 0;
+  if ((r = userlist_clnt_read_and_notify(clnt, &in_size, &void_in)) < 0)
+    return r;
+  struct userlist_packet *in = (struct userlist_packet *) void_in;
+  struct userlist_pk_login_ok *uin = 0;
+  if (in_size < sizeof(*in)) {
+    xfree(in);
+    return -ULS_ERR_PROTOCOL;
+  }
+  if (in->id == ULS_LOGIN_OK) {
+    uin = (struct userlist_pk_login_ok*) in;
+    if (in_size != sizeof(*uin)) {
+      xfree(in);
+      return -ULS_ERR_PROTOCOL;
+    }
+    if (p_user_id) *p_user_id = uin->user_id;
+    xfree(in);
+    return ULS_LOGIN_OK;
+  }
+
+  if (in_size != sizeof(*in)) {
+    xfree(in);
+    return -ULS_ERR_PROTOCOL;
+  }
+  r = in->id;
+  xfree(in);
+  return r;
+}
+
+/*
+ * Local variables:
+ *  compile-command: "make -C .."
+ * End:
+ */
